//
//  ViewController.swift
//  ApryseSample
//
//  Created by M Kalyan Chakravarthy on 14/12/24.
//

import UIKit
import PDFNet
import Tools

class ViewController: UIViewController {
    var documentController: PTDocumentController = PTDocumentController()
    
    let freetext: String = """
    <?xml version=\"1.0\" encoding=\"UTF-8\" ?><xfdf xmlns=\"http://ns.adobe.com/xfdf/\" xml:space=\"preserve\"><annots><freetext FontSize=\"12\" TextColor=\"#E44234\" creationdate=\"D:20241213165922+05'30'\" date=\"D:20241213165922+05'30'\" flags=\"print\" name=\"9c2918a9-163c-2a0b-f99c-f2617742262d\" page=\"0\" rect=\"287.76,741.908,367.9,756.29\" subject=\"Free Text\" title=\"Kalyan Chakravarthy Mupparaju\" width=\"0\">\n    <trn-custom-data bytes=\"{&quot;trn-auto-size-type&quot;:&quot;auto&quot;,&quot;trn-wrapped-text-lines&quot;:&quot;[\\&quot;Insert text here \\&quot;]&quot;}\"/>\n    <contents>Insert text here</contents>\n    <contents-richtext>\n        <body>\n            <p>\n                <span style=\"font-weight:normal;font-style:normal;text-decoration:none\">Insert text here</span>\n            </p>\n        </body>\n    </contents-richtext>\n    <defaultappearance>0 0 0 rg /Helvetica 12 Tf</defaultappearance>\n    <defaultstyle>font: Helvetica 12pt; text-align: left; text-vertical-align: top; color: #E44234</defaultstyle>\n</freetext>\n</annots></xfdf>
    """
    
    let line = """
<?xml version=\"1.0\" encoding=\"UTF-8\" ?><xfdf xmlns=\"http://ns.adobe.com/xfdf/\" xml:space=\"preserve\"><annots><line color=\"#E44234\" creationdate=\"D:20241213130028+05'30'\" date=\"D:20241213130029+05'30'\" end=\"517.35,670.06\" flags=\"print\" head=\"None\" name=\"b0d53581-9cc5-d7fc-956b-997698e8cb81\" page=\"0\" rect=\"296.98,666.02,519.351,672.061\" start=\"298.98,668.02\" subject=\"Line\" tail=\"None\" title=\"Kalyan Chakravarthy Mupparaju\" width=\"2\"/>\n</annots></xfdf>
"""

    override func viewDidLoad() {
        super.viewDidLoad()

        addChild(documentController)
        documentController.pdfViewCtrl.delegate = self
        documentController.view.frame = CGRect(x: 0, y: 0, width: view.frame.width, height: self.view.frame.height)
        self.view.addSubview(documentController.view)
        if let path = Bundle.main.path(forResource: "Order_Invoice6319391000", ofType: "pdf"), let doc = PTPDFDoc(filepath: path) {
            documentController.openDocument(with: doc)
        }
    }
    
    private func renderMarkups() {
        let xfdfStrs = [freetext]
        if let doc: PTPDFDoc = documentController.pdfViewCtrl.getDoc() {
            xfdfStrs.forEach { xfdf in
                doc.mergeXFDF(with: xfdf, opts: .none)
            }
            documentController.pdfViewCtrl.update(true)
        }
    }
}

extension ViewController: PTPDFViewCtrlDelegate {
    func pdfViewCtrl(_ pdfViewCtrl: PTPDFViewCtrl, onSetDoc doc: PTPDFDoc) {
        renderMarkups()
    }
}

